/*
	Interface for ID-RP2C

*/

#define	CONFIG_FILE	"/opt/dstar/conf/multi_forward.conf"
#define LOG_FILE	"/var/log/multi_forward.log"
#define	PID_FILE	"/var/run/multi_forward.pid"

#define	DSGWD_CONF	"/etc/dsgwd.conf"
#define DPRS_CONF	"/opt/dstar/conf/dprs.conf"

#define	TRUE		1
#define	FALSE		0
#define INVALID		2

#define ON	1
#define OFF	0

#define	GW	0x80
#define	ZR	0x40
#define	FWD	0x04
#define VOICE	0x12
#define DATA	0x11
#define	C_MASK	0x33
#define	POSIT	0x21
#define	XFWD	GW | ZR | FWD

#include	<stdint.h>
#include	<string.h>
#include	<ctype.h>
#include	<time.h>
#include	<sys/time.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<sys/socket.h>
#include 	<sys/types.h>
#include 	<netinet/in.h>
#include 	<netdb.h>
#include	<signal.h>
#include	<sys/ioctl.h>
#include	<sys/stat.h>
#include	<net/if.h>
#include	<errno.h>
#include	<sys/utsname.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>
#include	<unistd.h>
#include	<fcntl.h>
#include	<termios.h>
#include	"dstar.h"
#include	"packet.h"

#define	HOLE_PUNCH_SERVER	"hole-punch.d-star.info"
#define HOLE_PUNCH_PORT		30010
#define	TRUST_SERVER		"trust.d-star.info"
#define	TRUST_PORT		30001
#define CSS_FILE        	"/opt/dstar/web/dstar.css"
#define LOGO_FILE       	"/opt/dstar/web/logo.png"
#define JS_FILE         	"/opt/dstar/web/dstar.js"
#define	DCS_CONFIG_FILE		"/dstar/dcs_icom.cfg"

#define	NOP	0
#define	WAIT	1
#define	SKIP	2

#define	CON_AUTH	0x01
#define	XMIT_AUTH	0x02

struct	MultiConnectTable
{
	struct	MultiConnectTable	*f_chain;
	time_t		AccessTime;
	struct	sockaddr_in	multi_addr;
	char	callsign[8];
	long int	in;
	long int	out;
	long int	zr;
	long int	gw;
};

struct	MultiConnectTable	*MultiConnectTablePnt;

struct	MultiConnectReqTable
{
	struct  MultiConnectReqTable       *f_chain;
	struct	timeval          AccessTime;
	struct  sockaddr_in     multi_addr;
	char    callsign[8];
	char	type;
};

struct	MultiConnectReqTable	*MultiConnectReqTablePnt;

char	hole_punch_server[128];
int	hole_punch_port;
struct	addrinfo	*hole_punch_serv;

char	trust_server[128];
int	trust_port;
struct	addrinfo	*trust_serv;
int	trust_status;
struct  timeval send_inquire_time;

int	fwd_port;

int	reload;
int	debug_sw;
int	sig_term;

FILE	*log_file;
FILE	*pid_file;


fd_set          read_set;
fd_set		fd_save;


struct	sockaddr_in    	fwd_addr;
struct	sockaddr_in	multi_addr;
socklen_t		len_fwd_addr;
socklen_t		len_multi_addr;

struct	tm	*gt;

struct 	utsname      uname_buf;

struct	termios	termio_save;


sigset_t	save_sig;
sigset_t	sigset;
struct  timespec        timeout;

int	fwd_sd;
int	multi_port;
int	multi_sd;

struct  addrinfo        *multi_serv;

int	http_port;
int	http_sd;
struct	sockaddr_storage	http_recv;
struct	addrinfo		*http_serv;

int	cpu_fd;

time_t	cur_time;

int	hole_punch_interval;
int	hole_punch_port_save;

struct	area_callsign
{
	struct	area_callsign	*next;
	struct  timeval  rep_time;
	time_t	status_time;
	char	ar_callsign[8];
	char	FrameID[2];
	char	status;
	unsigned char	rf_header[58];
};

struct	area_callsign	*ar_callsign_pnt;

char	zr_callsign[8];

char	dcs_name[8];

char	forward_addr[128];

struct  FifoPkt
{
        struct  FifoPkt *next;
        int     length;
	struct	sockaddr_in	multi_addr;
        unsigned char pkt[1024];
};

struct  FifoPkt *Rp;
struct  FifoPkt *Wp;

struct  ctblPkt
{
        struct  ctblPkt *next;
        unsigned char pkt[44];
};

struct  ctblPkt *ctblRp;
struct  ctblPkt *ctblWp;

union
{
        struct  dstar_packet    d_packet;
        char    forward_buffer[256];
}       forward_buff;

union
{
        struct  dstar_packet    d_packet;
        char    multi_buffer[256];
}	multi_buff;

char	forward_buff_save[256];

unsigned int	multi_send_seq;

struct	timeval		recvtime;
